diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-mac.h ns-3.41/src/lr-wpan/model/lr-wpan-mac.h
--- ns-3.40/src/lr-wpan/model/lr-wpan-mac.h	2023-09-27 13:30:37.674839300 -0700
+++ ns-3.41/src/lr-wpan/model/lr-wpan-mac.h	2024-02-09 14:44:07.957790400 -0800
@@ -1042,124 +286,9 @@
      */
     Ptr<LrWpanPhy> GetPhy();
 
-    /**
-     * Set the callback for the indication of an incoming data packet.
-     * The callback implements MCPS-DATA.indication SAP of IEEE 802.15.4-2006,
-     * section 7.1.1.3.
-     *
-     * \param c the callback
-     */
-    void SetMcpsDataIndicationCallback(McpsDataIndicationCallback c);
-
-    /**
-     * Set the callback for the indication of an incoming associate request command.
-     * The callback implements MLME-ASSOCIATE.indication SAP of IEEE 802.15.4-2011,
-     * section 6.2.2.2.
-     *
-     * \param c the callback
-     */
-    void SetMlmeAssociateIndicationCallback(MlmeAssociateIndicationCallback c);
-
-    /**
-     * Set the callback for the indication to a response primitive.
-     * The callback implements MLME-COMM-STATUS.indication SAP of IEEE 802.15.4-2011,
-     * section 6.2.4.2.
-     *
-     * \param c the callback
-     */
-    void SetMlmeCommStatusIndicationCallback(MlmeCommStatusIndicationCallback c);
-
-    /**
-     * Set the callback for the indication to the reception of an orphan notification.
-     * The callback implements MLME-ORPHAN.indication SAP of IEEE 802.15.4-2011,
-     * section 6.2.7.1.
-     *
-     * \param c the callback
-     */
-    void SetMlmeOrphanIndicationCallback(MlmeOrphanIndicationCallback c);
-
-    /**
-     * Set the callback for the confirmation of a data transmission request.
-     * The callback implements MCPS-DATA.confirm SAP of IEEE 802.15.4-2006,
-     * section 7.1.1.2.
-     *
-     * \param c the callback
-     */
-    void SetMcpsDataConfirmCallback(McpsDataConfirmCallback c);
-
-    /**
-     * Set the callback for the confirmation of a data transmission request.
-     * The callback implements MLME-START.confirm SAP of IEEE 802.15.4-2006,
-     * section 7.1.14.2.
-     *
-     * \param c the callback
-     */
-    void SetMlmeStartConfirmCallback(MlmeStartConfirmCallback c);
-
-    /**
-     * Set the callback for the confirmation of a data transmission request.
-     * The callback implements MLME-SCAN.confirm SAP of IEEE 802.15.4-2011,
-     * section 6.2.10.2.
-     *
-     * \param c the callback
-     */
-    void SetMlmeScanConfirmCallback(MlmeScanConfirmCallback c);
-
-    /**
-     * Set the callback for the confirmation of a data transmission request.
-     * The callback implements MLME-ASSOCIATE.confirm SAP of IEEE 802.15.4-2011,
-     * section 6.2.2.4.
-     *
-     * \param c the callback
-     */
-    void SetMlmeAssociateConfirmCallback(MlmeAssociateConfirmCallback c);
-
-    /**
-     * Set the callback for the indication of an incoming beacon packet.
-     * The callback implements MLME-BEACON-NOTIFY.indication SAP of IEEE 802.15.4-2011,
-     * section 6.2.4.1.
-     *
-     * \param c the callback
-     */
-    void SetMlmeBeaconNotifyIndicationCallback(MlmeBeaconNotifyIndicationCallback c);
-
-    /**
-     * Set the callback for the loss of synchronization with a coordinator.
-     * The callback implements MLME-BEACON-NOTIFY.indication SAP of IEEE 802.15.4-2011,
-     * section 6.2.13.2.
-     *
-     * \param c the callback
-     */
-    void SetMlmeSyncLossIndicationCallback(MlmeSyncLossIndicationCallback c);
-
-    /**
-     * Set the callback for the confirmation of a data transmission request.
-     * The callback implements MLME-POLL.confirm SAP of IEEE 802.15.4-2011,
-     * section 6.2.14.2
-     *
-     * \param c the callback
-     */
-    void SetMlmePollConfirmCallback(MlmePollConfirmCallback c);
-
-    /**
-     * Set the callback for the confirmation of an attempt to write an attribute.
-     * The callback implements MLME-SET.confirm SAP of IEEE 802.15.4-2011,
-     * section 6.2.11.2
-     *
-     * \param c the callback
-     */
-    void SetMlmeSetConfirmCallback(MlmeSetConfirmCallback c);
-
-    /**
-     * Set the callback for the confirmation of an attempt to read an attribute.
-     * The callback implements MLME-GET.confirm SAP of IEEE 802.15.4-2011,
-     * section 6.2.5.2
-     *
-     *\param c the callback
-     */
-    void SetMlmeGetConfirmCallback(MlmeGetConfirmCallback c);
-
-    // interfaces between MAC and PHY
+    ////////////////////////////////////
+    // Interfaces between MAC and PHY //
+    ////////////////////////////////////
 
     /**
      * IEEE 802.15.4-2006 section 6.2.1.3
@@ -1231,20 +360,6 @@
     void SetLrWpanMacState(LrWpanMacState macState);
 
     /**
-     * Get the current association status.
-     *
-     * \return current association status
-     */
-    LrWpanAssociationStatus GetAssociationStatus() const;
-
-    /**
-     * Set the current association status.
-     *
-     * \param status new association status
-     */
-    void SetAssociationStatus(LrWpanAssociationStatus status);
-
-    /**
      * Set the max size of the transmit queue.
      *
      * \param queueSize The transmit queue size.
@@ -1828,9 +943,9 @@
      * Constructs a Superframe specification field from the local information,
      * the superframe Specification field is necessary to create a beacon frame.
      *
-     * \returns the Superframe specification field
+     * \returns the Superframe specification field (bitmap)
      */
-    SuperframeField GetSuperframeField();
+    uint16_t GetSuperframeField();
 
     /**
      * Constructs the Guaranteed Time Slots (GTS) Fields from local information.
@@ -2017,91 +1132,6 @@
     Ptr<LrWpanCsmaCa> m_csmaCa;
 
     /**
-     * This callback is used to report the result of an attribute writing request
-     * to the upper layers.
-     * See IEEE 802.15.4-2011, section 6.2.11.2.
-     */
-    MlmeSetConfirmCallback m_mlmeSetConfirmCallback;
-
-    /**
-     * This callback is used to report the result of an attribute read request
-     * to the upper layers.
-     * See IEEE 802.15.4-2011, section 6.2.5.2
-     */
-    MlmeGetConfirmCallback m_mlmeGetConfirmCallback;
-
-    /**
-     * This callback is used to notify incoming beacon packets to the upper layers.
-     * See IEEE 802.15.4-2011, section 6.2.4.1.
-     */
-    MlmeBeaconNotifyIndicationCallback m_mlmeBeaconNotifyIndicationCallback;
-
-    /**
-     * This callback is used to indicate the loss of synchronization with a coordinator.
-     * See IEEE 802.15.4-2011, section 6.2.13.2.
-     */
-    MlmeSyncLossIndicationCallback m_mlmeSyncLossIndicationCallback;
-
-    /**
-     * This callback is used to report the result of a scan on a group of channels for the
-     * selected channel page.
-     * See IEEE 802.15.4-2011, section 6.2.10.2.
-     */
-    MlmeScanConfirmCallback m_mlmeScanConfirmCallback;
-
-    /**
-     * This callback is used to report the status after a device request an association with
-     * a coordinator.
-     * See IEEE 802.15.4-2011, section 6.2.2.4.
-     */
-    MlmeAssociateConfirmCallback m_mlmeAssociateConfirmCallback;
-
-    /**
-     * This callback is used to report the status after a device send data command request to
-     * the coordinator to transmit data.
-     * See IEEE 802.15.4-2011, section 6.2.14.2.
-     */
-    MlmePollConfirmCallback m_mlmePollConfirmCallback;
-
-    /**
-     * This callback is used to report the start of a new PAN or
-     * the begin of a new superframe configuration.
-     * See IEEE 802.15.4-2006, section 7.1.14.2.
-     */
-    MlmeStartConfirmCallback m_mlmeStartConfirmCallback;
-
-    /**
-     * This callback is used to notify incoming packets to the upper layers.
-     * See IEEE 802.15.4-2006, section 7.1.1.3.
-     */
-    McpsDataIndicationCallback m_mcpsDataIndicationCallback;
-
-    /**
-     * This callback is used to indicate the reception of an association request command.
-     * See IEEE 802.15.4-2011, section 6.2.2.2
-     */
-    MlmeAssociateIndicationCallback m_mlmeAssociateIndicationCallback;
-
-    /**
-     * This callback is instigated through a response primitive.
-     * See IEEE 802.15.4-2011, section 6.2.4.2
-     */
-    MlmeCommStatusIndicationCallback m_mlmeCommStatusIndicationCallback;
-
-    /**
-     * This callback is used to indicate the reception of a orphan notification command.
-     * See IEEE 802.15.4-2011, section 6.2.7.1
-     */
-    MlmeOrphanIndicationCallback m_mlmeOrphanIndicationCallback;
-
-    /**
-     * This callback is used to report data transmission request status to the
-     * upper layers.
-     * See IEEE 802.15.4-2006, section 7.1.1.2.
-     */
-    McpsDataConfirmCallback m_mcpsDataConfirmCallback;
-
-    /**
      * The current state of the MAC layer.
      */
     TracedValue<LrWpanMacState> m_lrWpanMacState;
@@ -2117,11 +1147,6 @@
     TracedValue<SuperframeStatus> m_outSuperframeStatus;
 
     /**
-     * The current association status of the MAC layer.
-     */
-    LrWpanAssociationStatus m_associationStatus;
-
-    /**
      * The packet which is currently being sent by the MAC layer.
      */
     Ptr<Packet> m_txPkt;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-mac-header.cc ns-3.41/src/lr-wpan/model/lr-wpan-mac-header.cc
--- ns-3.40/src/lr-wpan/model/lr-wpan-mac-header.cc	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/model/lr-wpan-mac-header.cc	2024-02-09 14:44:07.953790400 -0800
@@ -120,7 +120,7 @@
 uint8_t
 LrWpanMacHeader::GetFrmCtrlRes() const
 {
-    return (m_fctrlReserved);
+    return m_fctrlReserved;
 }
 
 uint8_t
@@ -144,43 +144,43 @@
 uint8_t
 LrWpanMacHeader::GetSeqNum() const
 {
-    return (m_SeqNum);
+    return m_SeqNum;
 }
 
 uint16_t
 LrWpanMacHeader::GetDstPanId() const
 {
-    return (m_addrDstPanId);
+    return m_addrDstPanId;
 }
 
 Mac16Address
 LrWpanMacHeader::GetShortDstAddr() const
 {
-    return (m_addrShortDstAddr);
+    return m_addrShortDstAddr;
 }
 
 Mac64Address
 LrWpanMacHeader::GetExtDstAddr() const
 {
-    return (m_addrExtDstAddr);
+    return m_addrExtDstAddr;
 }
 
 uint16_t
 LrWpanMacHeader::GetSrcPanId() const
 {
-    return (m_addrSrcPanId);
+    return m_addrSrcPanId;
 }
 
 Mac16Address
 LrWpanMacHeader::GetShortSrcAddr() const
 {
-    return (m_addrShortSrcAddr);
+    return m_addrShortSrcAddr;
 }
 
 Mac64Address
 LrWpanMacHeader::GetExtSrcAddr() const
 {
-    return (m_addrExtSrcAddr);
+    return m_addrExtSrcAddr;
 }
 
 uint8_t
@@ -192,49 +192,49 @@
     val |= (m_secctrlKeyIdMode << 3) & (0x3 << 3); // Bit 3-4
     val |= (m_secctrlReserved << 5) & (0x7 << 5);  // Bit 5-7
 
-    return (val);
+    return val;
 }
 
 uint32_t
 LrWpanMacHeader::GetFrmCounter() const
 {
-    return (m_auxFrmCntr);
+    return m_auxFrmCntr;
 }
 
 uint8_t
 LrWpanMacHeader::GetSecLevel() const
 {
-    return (m_secctrlSecLevel);
+    return m_secctrlSecLevel;
 }
 
 uint8_t
 LrWpanMacHeader::GetKeyIdMode() const
 {
-    return (m_secctrlKeyIdMode);
+    return m_secctrlKeyIdMode;
 }
 
 uint8_t
 LrWpanMacHeader::GetSecCtrlReserved() const
 {
-    return (m_secctrlReserved);
+    return m_secctrlReserved;
 }
 
 uint32_t
 LrWpanMacHeader::GetKeyIdSrc32() const
 {
-    return (m_auxKeyIdKeySrc32);
+    return m_auxKeyIdKeySrc32;
 }
 
 uint64_t
 LrWpanMacHeader::GetKeyIdSrc64() const
 {
-    return (m_auxKeyIdKeySrc64);
+    return m_auxKeyIdKeySrc64;
 }
 
 uint8_t
 LrWpanMacHeader::GetKeyIdIndex() const
 {
-    return (m_auxKeyIdKeyIndex);
+    return m_auxKeyIdKeyIndex;
 }
 
 bool
@@ -597,7 +597,7 @@
             break;
         }
     }
-    return (size);
+    return size;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc ns-3.41/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc
--- ns-3.40/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc	2024-02-09 14:44:07.953790400 -0800
@@ -55,7 +55,7 @@
 BeaconPayloadHeader::GetSerializedSize() const
 {
     uint32_t size = 0;
-    size += m_superframeField.GetSerializedSize();
+    size += sizeof(m_superframeField);
     size += m_gtsFields.GetSerializedSize();
     size += m_pndAddrFields.GetSerializedSize();
 
@@ -66,7 +66,7 @@
 BeaconPayloadHeader::Serialize(Buffer::Iterator start) const
 {
     Buffer::Iterator i = start;
-    i = m_superframeField.Serialize(i);
+    i.WriteU16(m_superframeField);
     i = m_gtsFields.Serialize(i);
     i = m_pndAddrFields.Serialize(i);
 }
@@ -75,7 +75,7 @@
 BeaconPayloadHeader::Deserialize(Buffer::Iterator start)
 {
     Buffer::Iterator i = start;
-    i = m_superframeField.Deserialize(i);
+    m_superframeField = i.ReadU16();
     i = m_gtsFields.Deserialize(i);
     i = m_pndAddrFields.Deserialize(i);
 
@@ -91,7 +91,7 @@
 }
 
 void
-BeaconPayloadHeader::SetSuperframeSpecField(SuperframeField sf)
+BeaconPayloadHeader::SetSuperframeSpecField(uint16_t sf)
 {
     m_superframeField = sf;
 }
@@ -108,7 +108,7 @@
     m_pndAddrFields = pndAddrFields;
 }
 
-SuperframeField
+uint16_t
 BeaconPayloadHeader::GetSuperframeSpecField() const
 {
     return m_superframeField;
@@ -166,7 +166,7 @@
     switch (m_cmdFrameId)
     {
     case ASSOCIATION_REQ:
-        size += m_capabilityInfo.GetSerializedSize();
+        size += 1; // (Capability field)
         break;
     case ASSOCIATION_RESP:
         size += 3; // (short address + Association Status)
@@ -201,7 +201,7 @@
     switch (m_cmdFrameId)
     {
     case ASSOCIATION_REQ:
-        i = m_capabilityInfo.Serialize(i);
+        i.WriteU8(m_capabilityInfo);
         break;
     case ASSOCIATION_RESP:
         WriteTo(i, m_shortAddr);
@@ -240,11 +240,11 @@
     switch (m_cmdFrameId)
     {
     case ASSOCIATION_REQ:
-        i = m_capabilityInfo.Deserialize(i);
+        m_capabilityInfo = i.ReadU8();
         break;
     case ASSOCIATION_RESP:
         ReadFrom(i, m_shortAddr);
-        m_assocStatus = static_cast<AssocStatus>(i.ReadU8());
+        m_assocStatus = i.ReadU8();
         break;
     case DISASSOCIATION_NOTIF:
         break;
@@ -278,13 +278,15 @@
     os << "| MAC Command Frame ID | = " << static_cast<uint32_t>(m_cmdFrameId);
     switch (m_cmdFrameId)
     {
-    case ASSOCIATION_REQ:
-        os << "| Device Type FFD | = " << m_capabilityInfo.IsDeviceTypeFfd()
-           << "| Alternative Power Source available | = " << m_capabilityInfo.IsPowSrcAvailable()
-           << "| Receiver on when Idle | = " << m_capabilityInfo.IsReceiverOnWhenIdle()
-           << "| Security capable | = " << m_capabilityInfo.IsSecurityCapability()
-           << "| Allocate address on | = " << m_capabilityInfo.IsShortAddrAllocOn();
+    case ASSOCIATION_REQ: {
+        CapabilityField capability(m_capabilityInfo);
+        os << "| Device Type FFD | = " << capability.IsDeviceTypeFfd()
+           << "| Alternative Power Source available | = " << capability.IsPowSrcAvailable()
+           << "| Receiver on when Idle | = " << capability.IsReceiverOnWhenIdle()
+           << "| Security capable | = " << capability.IsSecurityCapability()
+           << "| Allocate address on | = " << capability.IsShortAddrAllocOn();
         break;
+    }
     case ASSOCIATION_RESP:
         os << "| Assigned Short Address | = " << m_shortAddr
            << "| Status Response | = " << m_assocStatus;
@@ -310,6 +312,8 @@
         break;
     case CMD_RESERVED:
         break;
+    default:
+        break;
     }
 }
 
@@ -320,7 +324,7 @@
 }
 
 void
-CommandPayloadHeader::SetCapabilityField(CapabilityField cap)
+CommandPayloadHeader::SetCapabilityField(uint8_t cap)
 {
     NS_ASSERT(m_cmdFrameId == ASSOCIATION_REQ);
     m_capabilityInfo = cap;
@@ -390,7 +394,7 @@
 }
 
 void
-CommandPayloadHeader::SetAssociationStatus(AssocStatus status)
+CommandPayloadHeader::SetAssociationStatus(uint8_t status)
 {
     NS_ASSERT(m_cmdFrameId == ASSOCIATION_RESP);
     m_assocStatus = status;
@@ -402,14 +406,14 @@
     return m_shortAddr;
 }
 
-CommandPayloadHeader::AssocStatus
+uint8_t
 CommandPayloadHeader::GetAssociationStatus() const
 {
     NS_ASSERT(m_cmdFrameId == ASSOCIATION_RESP);
     return m_assocStatus;
 }
 
-CapabilityField
+uint8_t
 CommandPayloadHeader::GetCapabilityField() const
 {
     NS_ASSERT(m_cmdFrameId == ASSOCIATION_REQ);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-mac-pl-headers.h ns-3.41/src/lr-wpan/model/lr-wpan-mac-pl-headers.h
--- ns-3.40/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2023-09-27 13:30:37.670839000 -0700
+++ ns-3.41/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2024-02-09 14:44:07.957790400 -0800
@@ -50,9 +50,9 @@
     void Print(std::ostream& os) const override;
     /**
      * Set the superframe specification field to the beacon payload header.
-     * \param sfrmField The superframe specification field
+     * \param sfrmField The superframe specification field (bitmap)
      */
-    void SetSuperframeSpecField(SuperframeField sfrmField);
+    void SetSuperframeSpecField(uint16_t sfrmField);
     /**
      * Set the superframe Guaranteed Time Slot (GTS) fields to the beacon payload header.
      * \param gtsFields The GTS fields.
@@ -65,9 +65,9 @@
     void SetPndAddrFields(PendingAddrFields pndAddrFields);
     /**
      * Get the superframe specification field from the beacon payload header.
-     * \return The superframe specification field
+     * \return The superframe specification field (bitmap)
      */
-    SuperframeField GetSuperframeSpecField() const;
+    uint16_t GetSuperframeSpecField() const;
     /**
      * Get the Guaranteed Time Slots (GTS) fields from the beacon payload header.
      * \return The GTS fields.
@@ -83,7 +83,7 @@
     /**
      * Superframe Specification Field
      */
-    SuperframeField m_superframeField;
+    uint16_t m_superframeField;
     /**
      * GTS Fields
      */
@@ -123,17 +123,6 @@
         CMD_RESERVED = 0xff          //!< Reserved
     };
 
-    /**
-     *  Association Status Field values.
-     *  See IEEE 802.15.4-2011, Table 6
-     */
-    enum AssocStatus
-    {
-        SUCCESSFUL = 0x00,    //!< Association successful
-        FULL_CAPACITY = 0x01, //!< PAN at capacity
-        ACCESS_DENIED = 0x02  //!< PAN access denied
-    };
-
     CommandPayloadHeader();
     /**
      * Constructor
@@ -161,7 +150,7 @@
      * Command).
      * \param cap The capability Information field
      */
-    void SetCapabilityField(CapabilityField cap);
+    void SetCapabilityField(uint8_t cap);
     /**
      *  Set the coordinator short address (16 bit address).
      * \param addr The coordinator short address.
@@ -192,7 +181,7 @@
      * Set status resulting from the association attempt (Association Response Command).
      * \param status The status resulting from the association attempt
      */
-    void SetAssociationStatus(AssocStatus status);
+    void SetAssociationStatus(uint8_t status);
     /**
      * Get the Short address assigned by the coordinator
      * (Association Response and Coordinator Realigment commands).
@@ -203,7 +192,7 @@
      * Get the status resulting from an association request (Association Response Command).
      * \return The resulting status from an association request
      */
-    AssocStatus GetAssociationStatus() const;
+    uint8_t GetAssociationStatus() const;
     /**
      * Get the command frame type ID
      * \return The command type ID from the command payload header
@@ -212,9 +201,9 @@
     /**
      * Get the Capability Information Field from the command payload header.
      * (Association Request Command)
-     * \return The Capability Information Field
+     * \return The Capability Information Field (8 bit bitmap)
      */
-    CapabilityField GetCapabilityField() const;
+    uint8_t GetCapabilityField() const;
     /**
      *  Get the coordinator short address.
      * \return The coordinator short address (16 bit address)
@@ -237,17 +226,17 @@
     uint16_t GetPanId() const;
 
   private:
-    MacCommand m_cmdFrameId;          //!< The command Frame Identifier (Used by all commands)
-    CapabilityField m_capabilityInfo; //!< Capability Information Field
-                                      //!< (Association Request Command)
-    Mac16Address m_shortAddr;         //!< Contains the short address assigned by the coordinator
-                              //!< (Association Response and Coordinator Realiagment Command)
+    MacCommand m_cmdFrameId;       //!< The command Frame Identifier (Used by all commands)
+    uint8_t m_capabilityInfo;      //!< Capability Information Field
+                                   //!< (Association Request Command)
+    Mac16Address m_shortAddr;      //!< Contains the short address assigned by the coordinator
+                                   //!< (Association Response and Coordinator Realiagment Command)
     Mac16Address m_coordShortAddr; //!< The coordinator short address
                                    //!< (Coordinator realigment command)
     uint16_t m_panid;              //!< The PAN identifier (Coordinator realigment command)
     uint8_t m_logCh;               //!< The channel number (Coordinator realigment command)
     uint8_t m_logChPage;           //!< The channel page number (Coordinator realigment command)
-    AssocStatus m_assocStatus;     //!< Association Status (Association Response Command)
+    uint8_t m_assocStatus;         //!< Association Status (Association Response Command)
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-net-device.cc ns-3.41/src/lr-wpan/model/lr-wpan-net-device.cc
--- ns-3.40/src/lr-wpan/model/lr-wpan-net-device.cc	2023-09-27 13:30:37.674839300 -0700
+++ ns-3.41/src/lr-wpan/model/lr-wpan-net-device.cc	2024-02-09 14:44:07.957790400 -0800
@@ -68,15 +68,16 @@
                           BooleanValue(true),
                           MakeBooleanAccessor(&LrWpanNetDevice::m_useAcks),
                           MakeBooleanChecker())
-            .AddAttribute("PseudoMacAddressMode",
-                          "Build the pseudo-MAC Address according to RFC 4944 or RFC 6282 "
-                          "(default: RFC 6282).",
-                          EnumValue(LrWpanNetDevice::RFC6282),
-                          MakeEnumAccessor(&LrWpanNetDevice::m_pseudoMacMode),
-                          MakeEnumChecker(LrWpanNetDevice::RFC6282,
-                                          "RFC 6282 (don't use PanId)",
-                                          LrWpanNetDevice::RFC4944,
-                                          "RFC 4944 (use PanId)"));
+            .AddAttribute(
+                "PseudoMacAddressMode",
+                "Build the pseudo-MAC Address according to RFC 4944 or RFC 6282 "
+                "(default: RFC 6282).",
+                EnumValue(LrWpanNetDevice::RFC6282),
+                MakeEnumAccessor<PseudoMacAddressMode_e>(&LrWpanNetDevice::m_pseudoMacMode),
+                MakeEnumChecker(LrWpanNetDevice::RFC6282,
+                                "RFC 6282 (don't use PanId)",
+                                LrWpanNetDevice::RFC4944,
+                                "RFC 4944 (use PanId)"));
     return tid;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lr-wpan/model/lr-wpan-phy.cc ns-3.41/src/lr-wpan/model/lr-wpan-phy.cc
--- ns-3.40/src/lr-wpan/model/lr-wpan-phy.cc	2023-09-27 13:30:37.674839300 -0700
+++ ns-3.41/src/lr-wpan/model/lr-wpan-phy.cc	2024-02-09 14:44:07.957790400 -0800
@@ -87,6 +87,61 @@
     {8.0, 2.0, 2.0},
 };
 
+std::ostream&
+operator<<(std::ostream& os, const LrWpanPhyEnumeration& state)
+{
+    switch (state)
+    {
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_BUSY:
+        os << "BUSY";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_BUSY_RX:
+        os << "BUSY_RX";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_BUSY_TX:
+        os << "BUSY_TX";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_FORCE_TRX_OFF:
+        os << "FORCE_TRX_OFF";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_IDLE:
+        os << "IDLE";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_INVALID_PARAMETER:
+        os << "INVALID_PARAMETER";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_RX_ON:
+        os << "RX_ON";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_SUCCESS:
+        os << "SUCCESS";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_TRX_OFF:
+        os << "TRX_OFF";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_TX_ON:
+        os << "TX_ON";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_UNSUPPORTED_ATTRIBUTE:
+        os << "UNSUPPORTED";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_READ_ONLY:
+        os << "READ_ONLY";
+        break;
+    case LrWpanPhyEnumeration::IEEE_802_15_4_PHY_UNSPECIFIED:
+        os << "UNSPECIFIED";
+        break;
+    }
+    return os;
+};
+
+std::ostream&
+operator<<(std::ostream& os, const TracedValue<LrWpanPhyEnumeration>& state)
+{
+    LrWpanPhyEnumeration s = state;
+    return os << s;
+};
+
 TypeId
 LrWpanPhy::GetTypeId()
 {
@@ -241,14 +296,12 @@
 Ptr<NetDevice>
 LrWpanPhy::GetDevice() const
 {
-    NS_LOG_FUNCTION(this);
     return m_device;
 }
 
 Ptr<MobilityModel>
 LrWpanPhy::GetMobility() const
 {
-    NS_LOG_FUNCTION(this);
     return m_mobility;
 }
 
@@ -297,7 +350,6 @@
 Ptr<Object>
 LrWpanPhy::GetAntenna() const
 {
-    NS_LOG_FUNCTION(this);
     return m_antenna;
 }
 
@@ -548,6 +600,10 @@
 
         if (!m_currentRxPacket.second)
         {
+            m_currentRxPacket = std::make_pair(nullptr, true);
+            ChangeTrxState(IEEE_802_15_4_PHY_RX_ON);
+            NS_LOG_DEBUG("Packet successfully received");
+
             // The packet was successfully received, push it up the stack.
             if (!m_pdDataIndicationCallback.IsNull())
             {
@@ -556,43 +612,22 @@
         }
         else
         {
-            // The packet was destroyed, drop it.
+            // The packet was destroyed due to interference, post-rx corruption or
+            // cancelled, therefore drop it.
             m_phyRxDropTrace(currentPacket);
-        }
-        Ptr<LrWpanSpectrumSignalParameters> none = nullptr;
-        m_currentRxPacket = std::make_pair(none, true);
+            m_currentRxPacket = std::make_pair(nullptr, true);
 
-        if (!m_isRxCanceled)
-        {
-            // We may be waiting to apply a pending state change.
-            if (m_trxStatePending != IEEE_802_15_4_PHY_IDLE)
+            if (!m_isRxCanceled)
             {
-                // Only change the state immediately, if the transceiver is not already
-                // switching the state.
-                if (!m_setTRXState.IsRunning())
-                {
-                    NS_LOG_LOGIC("Apply pending state change to " << m_trxStatePending);
-                    ChangeTrxState(m_trxStatePending);
-                    m_trxStatePending = IEEE_802_15_4_PHY_IDLE;
-                    if (!m_plmeSetTRXStateConfirmCallback.IsNull())
-                    {
-                        m_plmeSetTRXStateConfirmCallback(IEEE_802_15_4_PHY_SUCCESS);
-                    }
-                }
+                ChangeTrxState(IEEE_802_15_4_PHY_RX_ON);
             }
             else
             {
-                ChangeTrxState(IEEE_802_15_4_PHY_RX_ON);
+                // The state of The PHY was already changed when the packet was canceled
+                // due to a forced operation.
+                m_isRxCanceled = false;
             }
         }
-        else
-        {
-            // A TX event was forced during the reception of the frame.
-            // There is no need to change the PHY state after handling the signal,
-            // because the Forced TX already changed the PHY state.
-            // Return flag to default state
-            m_isRxCanceled = false;
-        }
     }
 }
 
@@ -776,6 +811,7 @@
                 (state != IEEE_802_15_4_PHY_FORCE_TRX_OFF) && (state != IEEE_802_15_4_PHY_TX_ON));
 
     NS_LOG_LOGIC("Trying to set m_trxState from " << m_trxState << " to " << state);
+
     // this method always overrides previous state setting attempts
     if (!m_setTRXState.IsExpired())
     {
@@ -1321,6 +1357,7 @@
 LrWpanPhy::ChangeTrxState(LrWpanPhyEnumeration newState)
 {
     NS_LOG_LOGIC(this << " state: " << m_trxState << " -> " << newState);
+
     m_trxStateLogger(Simulator::Now(), m_trxState, newState);
     m_trxState = newState;
 }
@@ -1560,8 +1597,6 @@
 double
 LrWpanPhy::GetDataOrSymbolRate(bool isData)
 {
-    NS_LOG_FUNCTION(this << isData);
-
     double rate = 0.0;
 
     NS_ASSERT(m_phyOption < IEEE_802_15_4_INVALID_PHY_OPTION);
@@ -1691,10 +1726,8 @@
     SetRxSensitivity(-106.58);
 
     m_rxLastUpdate = Seconds(0);
-    Ptr<Packet> none_packet = nullptr;
-    Ptr<LrWpanSpectrumSignalParameters> none_params = nullptr;
-    m_currentRxPacket = std::make_pair(none_params, true);
-    m_currentTxPacket = std::make_pair(none_packet, true);
+    m_currentRxPacket = std::make_pair(nullptr, true);
+    m_currentTxPacket = std::make_pair(nullptr, true);
     m_errorModel = nullptr;
 }
 
